module.exports = {
  "env": {
    "browser": true
  },
  "extends": "eslint:recommended",
  "rules": {
    "consistent-return": ["error"],
    "block-scoped-var": ["error"],
    "no-use-before-define": ["error"],
    //"curly": ["error", "multi-line", "consistent"],
    "brace-style": ["error"],
    "func-call-spacing": ["error", "always"],
    "func-style": ["error", "declaration"],
    "curly": ["off"],
    "no-unused-vars": ["error", { vars: "local" }],
    "no-console": ["off"],
    "no-undef": ["off"],
    "indent": ["error", 4, { SwitchCase: 1 }],
    "linebreak-style": ["error", "unix"],
    "quotes": ["error", "double"],
    "semi": ["error", "always"],
    "no-array-constructor": ["error"],
    //"no-mixed-operators": ["error"],
    "no-multiple-empty-lines": ["error", { max: 1, maxEOF: 2, maxBOF: 0 }],
    "no-tabs": ["error"],
    "no-trailing-spaces": ["error", { skipBlankLines: true }],
    "no-whitespace-before-property": ["error"],
    "object-curly-spacing": ["error", "always"],
    "operator-linebreak": ["error", "before"],
    "padded-blocks": ["warn", "never"],
    "semi-spacing": ["error", { before: false, after: true }],
    "space-before-blocks": ["error", "always"],
    "space-before-function-paren": ["error", "always"],
    "space-in-parens": ["error", "never"],
    "space-infix-ops": ["error"],
    "space-unary-ops": ["error", { words: true, nonwords: false}],
    "spaced-comment": ["warn", "always"],
    "arrow-spacing": ["error", { before: true, after: true }],
    "keyword-spacing": ["error", { before: true, after: true }],
    "eol-last": ["error", "always"],

    "newline-after-var": ["warn"],
    "newline-before-return": ["warn"],
  }
};
